<?php

/**
* @copyright	Copyright (C) 2009 - 2014 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	GNU/GPL, see LICENSE.php
* @package	Payplans
* @subpackage	Payflow Payment App
* @contact	support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

define('PAYPLANS_PAYFLOW_SETTLEMENT_PENDING', 6);
define('PAYPLANS_PAYFLOW_SETTLEMENT_SUCCESS', 8);
define('PAYPLANS_PAYFLOW_ERROR',1);
define('PAYPLANS_PAYFLOW_FAILED_TO_SETTLE',11);
define('PAYPLANS_PAYFLOW_SETLEMENT_INCOMPLETE', 14);

/**
 * Payplans payflow Plugin
 */
class plgPayplansPayflow extends XiPlugin
{
	public function onPayplansSystemStart()
	{
		$appPath = dirname(__FILE__).DS.'payflow'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);

		return true;
	}
	
	public function onPayplansCron()
	{
		$now = new XiDate();
		$prevDate = new XiDate();
		$prevDate->subtractExpiration('000003000000');

		$queryFilters = array('type'=>'payflow');
		$apps		  = XiFactory::getInstance('app', 'model')->loadRecords($queryFilters);
		$payflowApps  = array();
		foreach($apps as $app){
			$payflowApp = PayplansApp::getInstance( $app->app_id, $app->type, $app);
			if($payflowApp === FALSE){
				continue;
			}
			$payflowApps[$app->app_id] = $payflowApp; 
		}

		$payflowId  = array_keys($payflowApps);
		
		if(empty($payflowId))
		{
			return true;
		}

        $db = JFactory::getDBO();
        $query = "SELECT * FROM ". $db->quoteName('#__payplans_payment')."WHERE `app_id` IN (".implode(",", $payflowId).") 
                   AND `modified_date` <= '".$now->toMySQL()."' AND `modified_date` >= '".$prevDate->toMySQL()."'";
        
         $db->setQuery($query);
         $payments = $db->loadObjectList();
		  foreach ($payments as $payment)
		  {
			if(JDEBUG)
			{
				file_put_contents(JPATH_SITE.DS.'tmp'.DS.'payment.txt', var_export($payment->payment_id,true), FILE_APPEND);
			}
		  	$appInstance = $payflowApps[$payment->app_id];
			$appParam    = $appInstance->getAppParams()->toArray();
			$transtate   = PAYPLANS_PAYFLOW_SETTLEMENT_SUCCESS;
		    if($appParam['sandboxTesting']){
			    $transtate = PAYPLANS_PAYFLOW_SETTLEMENT_PENDING;
		    }
			
			$payment     = PayplansPayment::getInstance($payment->payment_id);
		  	$profileId   = $payment->getGatewayParam('profile_id');
		  	if(!isset($profileId))
		  	  continue;
		  	$invoice = $payment->getInvoice(true);
		  	$count	 = $invoice->getCounter();
		    $total   = $invoice->getTotal($count);
		  	if($count == 1 && $invoice->isRecurring() && $invoice->getStatus() == PayplansStatus::INVOICE_CONFIRMED)
		  	{
		  	  $httpParsedResponseAr = $this->executeApi($profileId,$appParam);
		  	  $transactions = $this->_getExistingTransaction($invoice->getId(), $httpParsedResponseAr['P_PNREF1'],0,0);
		  	  
			  if($transactions !== false){
	    		foreach($transactions as $trans){
	    		$trans = PayplansTransaction::getInstance($trans->transaction_id, null, $trans);
	    		if( $trans->get('gateway_txn_id','') == $httpParsedResponseAr['P_PNREF1']){
    				return true;
    			}
	    			}
	    		}
		  	  
		  	  if($httpParsedResponseAr['P_RESULT1'] == 0 && isset($httpParsedResponseAr['P_TRANSTATE1'])
		  	       && $httpParsedResponseAr['P_TRANSTATE1'] == $transtate && $httpParsedResponseAr['P_AMT1'] == $total)
		  		{
		  			$transaction = PayplansTransaction::getInstance();
		            $transaction->set('user_id', $invoice->getBuyer())
								->set('invoice_id', $invoice->getId())
								->set('payment_id', $payment->getId())
								->set('gateway_txn_id', $httpParsedResponseAr['P_PNREF1'])
								->set('gateway_subscr_id', 0)
								->set('amount', $httpParsedResponseAr['P_AMT1'])
								->set('params', PayplansHelperParam::arrayToIni($httpParsedResponseAr))
								->set('message',XiText::_("COM_PAYPLANS_APP_PAYFLOW_RECURRING_PAYMENT_COMPLETED"));
					
					if(!$transaction->save()){
						$message = XiText::_('COM_PAYPLANS_LOGGER_ERROR_TRANSACTION_SAVE_FAILD');
						PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $httpParsedResponseAr, 'PayplansPaymentFormatter', '', true);
					}
			    $payment->save();	
		  		}
				elseif(isset($httpParsedResponseAr['P_RESULT1']) && $httpParsedResponseAr['P_RESULT1'] != 0){
					
					$transaction = PayplansTransaction::getInstance();
		            $transaction->set('user_id', $invoice->getBuyer())
								->set('invoice_id', $invoice->getId())
								->set('payment_id', $payment->getId())
								->set('gateway_txn_id', 0)
								->set('gateway_subscr_id', 0)
								->set('amount', 0)
								->set('params', PayplansHelperParam::arrayToIni($httpParsedResponseAr))
								->set('message',XiText::_("COM_PAYPLANS_APP_PAYFLOW_RECURRING_PAYMENT_NOT_COMPLETED"));
					
					if(!$transaction->save()){
						$message = XiText::_('COM_PAYPLANS_LOGGER_ERROR_TRANSACTION_SAVE_FAILD');
						PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, $httpParsedResponseAr,'PayplansPaymentFormatter', '', true);
					}

				}
		  			
		  		}
		  	}
		  }   
	
	function executeApi($profileId,$appParam)
	{
		$API_Vendor   = $appParam['vendor'];
		$API_User     = empty($appParam['user'])? $API_Vendor:$appParam['user'];
		$API_Partner  = $appParam['partner'];
		$API_Password = $appParam['password'];
		$API_Endpoint = "https://payflowpro.paypal.com";
		
     	if($appParam['sandboxTesting']){
			$API_Endpoint ="https://pilot-payflowpro.paypal.com";
		}
		$version = urlencode('51.0');
	
		// Set the curl parameters.
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $API_Endpoint);
		curl_setopt($ch, CURLOPT_VERBOSE, 1);
	
		// Turn off the server and peer verification (TrustManager Concept).
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
	
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		$nvpstr  =  "TRXTYPE=R&PARTNER=$API_Partner&VENDOR=$API_Vendor&USER=$API_User&PWD=$API_Password";
		$nvpstr .=  "&ACTION=I&PAYMENTHISTORY=Y&ORIGPROFILEID=$profileId";
		
		// Set the request as a POST FIELD for curl.
		curl_setopt($ch, CURLOPT_POSTFIELDS, $nvpstr);
		
		$httpResponse = curl_exec($ch);

		if(JDEBUG){
				file_put_contents(JPATH_SITE.DS.'tmp'.DS.'inquiry'.time(), var_export($httpResponse,true), FILE_APPEND);
			}
		
		if(!$httpResponse) {
			$error = curl_error($ch).'('.curl_errno($ch).')';
			$message = XiText::_('COM_PAYPLANS_PAYMENT_APP_PAYFLOW_PRO_FAILED_MESSAGE');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, array($error));
		}

		// Extract the response details.
		$httpResponseAr = explode("&", $httpResponse);
	
		$httpParsedResponseAr = array();
		foreach ($httpResponseAr as $i => $value) {
			$tmpAr = explode("=", $value);
			if(sizeof($tmpAr) > 1) {
				$httpParsedResponseAr[$tmpAr[0]] = $tmpAr[1];
			}
		}
	
		if((0 == sizeof($httpParsedResponseAr)) || !array_key_exists('RESULT', $httpParsedResponseAr)) {
			$error = "Invalid HTTP Response for POST request($nvpreq) to $API_Endpoint.";
			$message = "$methodName_ ".XiText::_('COM_PAYPLANS_APP_PAYPAL_PRO_FAILED_MESSAGE');
			PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, $payment, array($error));
		}
	
		return $httpParsedResponseAr;	
	}
	
	
	protected function _getExistingTransaction($invoiceid, $txn_id, $subscr_id, $parent_txn)
	{
		// if all arguments are empty or then return exists
		if(empty($txn_id) && empty($subscr_id) && empty($parent_txn)){
			return true;
		}
		
		$model = XiFactory::getInstance('transaction', 'model');
		$filter = array();
		$filter['invoice_id']			= $invoiceid;
		$filter['gateway_txn_id'] 		= $txn_id; 
		$filter['gateway_subscr_id'] 	= $subscr_id;
		$filter['gateway_parent_txn'] 	= $parent_txn;
		
		$result = $model->loadRecords($filter);
		if(count($result)){
			return $result;
		}
		
		return false;
	}	
}
